models/Misiones.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "misiones".
 *
 * @property string $nom_mis
 * @property string|null $informe
 * @property int|null $dificultad
 * @property int|null $recompensa
 *
 * @property Realizan[] $realizans
 */
class Misiones extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'misiones';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['nom_mis'], 'required'],
            [['informe'], 'string'],
            // Añade la regla 'in' para 'dificultad' y 'recompensa'
            [['dificultad'], 'in', 'range' => [1, 2, 3]],
            [['recompensa'], 'in', 'range' => [1]],
            [['nom_mis'], 'string', 'max' => 30],
            [['nom_mis'], 'unique'],
            [['pago'], 'integer']
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'nom_mis' => 'Nom Mis',
            'informe' => 'Informe',
            'dificultad' => 'Dificultad',
            'recompensa' => 'Recompensa',
            'pago' => 'Pago',
        ];
    }
    
    // Establece la recompensa por defecto en 1
    public function init()
    {
        parent::init();
        
        $this->recompensa = 1;
    }

    /**
     * Gets query for [[Realizans]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getRealizans()
    {
        return $this->hasMany(Realizan::class, ['nom_mis' => 'nom_mis']);
    }
    
    
    
    
    
}

controllers/MisionesController.php
<?php

namespace app\controllers;


use app\models\misiones;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use app\models\Monedero;


use app\models\Tripulantes;

/**
 * MisionesController implements the CRUD actions for misiones model.
 */
class MisionesController extends Controller
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all misiones models.
     *
     * @return string
     */
    public function actionIndex()
    {
        
        $misiones = Misiones::find()->all();
        $tripulantes = Tripulantes::find();
        $dataProvider = new ActiveDataProvider([
            
            'query' => misiones::find(),
            /*
            'pagination' => [
                'pageSize' => 50
            ],
            'sort' => [
                'defaultOrder' => [
                    'nom_mis' => SORT_DESC,
                ]
            ],
            */
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
            'misiones' => $misiones,
            'tripulantes' => $tripulantes,
            
        ]);
    }


    /**
     * Displays a single misiones model.
     * @param string $nom_mis Nom Mis
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($nom_mis)
    {
        return $this->render('view', [
            'model' => $this->findModel($nom_mis),
        ]);
    }
    
    
    
    public function actionViewPlanetas($cod_planetas)
    {
        $misiones = Mision::findAll(['cod_planetas' => $cod_planetas]);

        return $this->render('view', [
            'misiones' => $misiones,
        ]);
    }
    
    
    
    
    
    
    
    

    /**
     * Creates a new misiones model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
    {
        $model = new misiones();

        if ($this->request->isPost) {
            if ($model->load($this->request->post()) && $model->save()) {
                return $this->redirect(['index', 'nom_mis' => $model->nom_mis]);
            }
        } else {
            $model->loadDefaultValues();
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing misiones model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param string $nom_mis Nom Mis
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($nom_mis)
    {
        $model = $this->findModel($nom_mis);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['index', 'nom_mis' => $model->nom_mis]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing misiones model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param string $nom_mis Nom Mis
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($nom_mis)
    {
        $this->findModel($nom_mis)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the misiones model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param string $nom_mis Nom Mis
     * @return misiones the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($nom_mis)
    {
        if (($model = misiones::findOne(['nom_mis' => $nom_mis])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    
    
    
    
    
    
    
    
    
    public function actionCompletar($nom_mis)
    {
        // Obtener la misión
        $mision = Misiones::findOne($nom_mis);

        if ($mision) {
            // Obtener la recompensa y el pago de la misión
            $recompensa = $mision->recompensa;
            $pago = $mision->pago;

            // Actualizar el nivel de los tripulantes
            Tripulantes::updateAllCounters(['nivel' => $recompensa]);

            // Obtener el monedero con cod_mon = 1
            $monedero = Monedero::findOne(1);

            // Verificar si el monedero existe
            if ($monedero) {
                // Sumar el pago al monedero
                $monedero->cantidad += $pago;
                // Guardar los cambios en el monedero
                $monedero->save();
            } else {
                // Si no existe el monedero, puedes decidir qué acción tomar
                Yii::$app->session->setFlash('error', 'El monedero no existe.');
            }

            // Redirigir a la vista de misiones
            return $this->redirect(['misiones/index']);
        } else {

            Yii::$app->session->setFlash('error', 'La misión no existe.');
            return $this->redirect(['misiones/index']);
        }
    }
    
    
    
    public function actionMostrar()
    {
        //  modelo Misiones está cargado y accesible aquí
        $misionesNivel1 = Misiones::find()->where(['dificultad' => 1])->all();

        return $this->render('mostrar', [
            'misionesNivel1' => $misionesNivel1,
        ]);
    }
    
    
    
    public function actionMostrar1()
    {
        $misionesNivel2 = Misiones::find()->where(['dificultad' => 2])->all();

        return $this->render('mostrar1', [
            'misionesNivel2' => $misionesNivel2,
        ]);
    }



    public function actionMostrar2()
    {
        $misionesNivel3 = Misiones::find()->where(['dificultad' => 3])->all();

        return $this->render('mostrar2', [
            'misionesNivel3' => $misionesNivel3,
        ]);
    }


    
    

    
    
    
    
    
    
}

views/misiones/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/** @var yii\web\View $this */
/** @var app\models\misiones $model */
/** @var yii\widgets\ActiveForm $form */
?>

<div class="misiones-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'nom_mis')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'informe')->textarea(['rows' => 6]) ?>

    <?= $form->field($model, 'dificultad')->dropDownList(
        [1 => '1', 2 => '2', 3 => '3'], // Opciones del desplegable
        ['prompt' => 'Seleccione la dificultad'] // Texto del placeholder
    ) ?>
    
    
    <!-- BOTON MASCOTA INSTRUCCIONES PARA LA DIFICULTAD -->
    <?= Html::a('?', [''], ['class' => 'btn btn-primary btn-fijo', 'id' => 'boton-toggle']) ?>



    <!-- CONTENEDOR MASCOTA -->
    <div id="imagen-container" style="display: none; position: fixed; bottom: 100px; right: 30px; z-index: 101;">
        <img class="d-block w-1" src="<?= Yii::getAlias('@web')?>/img/prueba.png" style="width: 500px; height: auto;">
    </div>




    <!-- JS MANEJAR MASCOTA -->
    <script>
    document.getElementById('boton-toggle').addEventListener('click', function(event) {
        // Previene el comportamiento por defecto del enlace
        event.preventDefault();

        var boton = this;
        var imagenContainer = document.getElementById('imagen-container');

        // Verifica si la imagen ya está visible
        if (imagenContainer.style.display === 'none') {
            // Muestra la imagen
            imagenContainer.style.display = 'block';

            // Cambia la apariencia del botón a 'X'
            boton.innerHTML = 'X';
        } else {
            // Oculta la imagen
            imagenContainer.style.display = 'none';

            // Restablece la apariencia del botón a '?'
            boton.innerHTML = '?';
        }
    });
    </script>

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    

    
    <?= $form->field($model, 'pago')->textInput() ?>

    <div class="form-group">
        <?= Html::submitButton('Save', ['class' => 'btn btn-success']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/misiones/index.php
<?php

use app\models\misiones;
use yii\helpers\Html;
use yii\helpers\Url;
use yii\grid\ActionColumn;
use yii\grid\GridView;

/** @var yii\web\View $this */
/** @var yii\data\ActiveDataProvider $dataProvider 

$this->title = 'Misiones';
$this->params['breadcrumbs'][] = $this->title;
*/
?>
<div class="misiones-index">

    <h1><?= Html::encode($this->title) ?></h1>

    
    <div class="container mt-5">
        <div class="mis-exp">
            <img src="<?= Yii::getAlias('@web') ?>/img/Slider-pla.jpg" alt="Imagen" width="60px"  class="mis-fondo">
            <h2 class="titulo-mis">Misiones</h2>
        </div>
    </div>

    <style>
        .mis-exp {
            position: relative;
            border: 3px solid #AAD399;
            padding: 20px;
            color: #AAD399;
            box-shadow: 0 0 20px rgba(0, 255, 204, 0.5);
            text-shadow: 0 0 5px #AAD399;
            margin-bottom: 50px;
        }
        .mis-fondo {
            position: absolute;
            top: 0;
            left: 0;
            width: 100%;
            height: 100%;
            object-fit: cover;
            z-index: -1;
        }
        .titulo-mis {
            color: #F5DF61;
            text-shadow: 0 0 10px #F5DF61;
            position: relative;
            z-index: 1;
        }
    </style>
    <p>
        <?= Html::a('Crear Misiones', ['create'], ['class' => 'btn btn-success']) ?>

    </p>
    
    <style>
        .btn.btn-success {
        /* tamaño del botón */
            padding: 10px 20px; 
            font-size: 1em; 
            border: none;
            border-radius: 20px;
            background-color: #AAD399;
            color: black; 
            display: inline-block;
            cursor: pointer;
            box-shadow: 0 4px #759e64; 
            transition-duration: 0.4s;
        }

        .btn.btn-success:hover {
            background-color: #F5DF61;
            box-shadow: 0 4px #c9b649;
        }

        .btn.btn-success:active {
            background-color: #3e8e41; 
            box-shadow: 0 2px #666; 
            transform: translateY(2px); 
        }
    </style>

    
    
        
    </div>


    <h1><?= Html::encode($this->title) ?></h1>  
    
    
    
    
    
    
    <section class="pt-5 pb-5">
    <div class="container">
        <div class="row">
            <div class="col-6">
                <h3 class="mb-3">Planetas </h3>
            </div>
            
            
                
            </div>
            
            
            <div class="col-12">
                <div id="carouselExampleIndicators2" class="carousel slide" data-ride="carousel">

                    <div class="carousel-inner">
                        
                        <!-- SET 1 -->
                        <div class="carousel-item active">
                            <div class="row">

                                <div class="col-md-4 mb-3">
                                    <div class="card">
                                        <img class="img-fluid" alt="100%x280" src="<?= Yii::getAlias('@web')?>/img/DESTINOS/venus.png">
                                        <div class="card-body">
                                            <h4 class="card-title">Venus</h4>
                                            <p class="card-text"> </p>
                                            
                                            
                                            <!--BOTON NIVEL -5-->
                                            <!--Consulta si existe al menos un tripulante con un nivel mayor o igual a 1 en la base de datos-->
                                                <?php
        
        
                                                    $habilitarBoton = $tripulantes->andWhere(['>=', 'nivel', 1])->exists(); // COMPRUEBO SI NIVEL>= 10

                                                    if ($habilitarBoton) {
                                                        echo Html::a('Ver Misiones Nivel 1', ['misiones/mostrar'], ['class' => 'btn btn-success']);
                                                    } else {
                                                        echo Html::button('Ver Misiones Nivel 1', ['class' => 'btn btn-success', 'disabled' => true]);
                                                    }


                                                ?> 

                                            

                                        </div>

                                    </div>
                                </div>
                                
                                
                                <div class="col-md-4 mb-3">
                                    <div class="card">
                                        <img class="img-fluid" alt="100%x280" src="<?= Yii::getAlias('@web')?>/img/DESTINOS/marte.png">
                                        <div class="card-body">
                                            <h4 class="card-title">Marte</h4>
                                            <p class="card-text"> </p>
                                            
                                            
                                            <!--BOTON NIVEL >=5-->
                                            <!--Consulta si existe al menos un tripulante con un nivel mayor o igual a 5 en la base de datos-->
                                                <?php


                                                    $habilitarBoton = $tripulantes->andWhere(['>=', 'nivel', 5])->exists(); // COMPRUEBO SI NIVEL>= 5

                                                    if ($habilitarBoton) {
                                                        echo Html::a('Ver Misiones Nivel 2', ['misiones/mostrar1'], ['class' => 'btn btn-success']);
                                                    } else {
                                                        echo Html::button('Ver Misiones Nivel 2', ['class' => 'btn btn-success', 'disabled' => true]);
                                                    }


                                                ?>

                                        </div>
                                    </div>
                                </div>
                                <div class="col-md-4 mb-3">
                                    <div class="card">
                                        <img class="img-fluid" alt="100%x280" src="<?= Yii::getAlias('@web')?>/img/DESTINOS/orcus.png">
                                        <div class="card-body">
                                            <h4 class="card-title">Orcus</h4>
                                            <p class="card-text"> </p>
                                            
                                            
                                            <!--BOTON NIVEL >=10-->
                                            <!--Consulta si existe al menos un tripulante con un nivel mayor o igual a 10 en la base de datos-->
                                                 <?php


                                                    $habilitarBoton = $tripulantes->andWhere(['>=', 'nivel', 10])->exists(); // COMPRUEBO SI NIVEL>= 10

                                                    if ($habilitarBoton) {
                                                        echo Html::a('Ver Misiones Nivel 3', ['misiones/mostrar2'], ['class' => 'btn btn-success']);
                                                    } else {
                                                        echo Html::button('Ver Misiones Nivel 3', ['class' => 'btn btn-success', 'disabled' => true]);
                                                    }


                                                ?>
    
                                            
                                            

                                        </div>
                                    </div>
                                </div>

                            </div>
                        </div>
                        
                        <!-- SET 2 -->
                        
                        
                        
                        
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>
    

    

    





    
    
    
    
    
    
    
    


    


    
    
    
    
    
 <!-- BOTON MASCOTA -->
<?= Html::a('?', [''], ['class' => 'btn btn-primary btn-fijo', 'id' => 'boton-toggle']) ?>

<!-- CONTENEDOR MASCOTA -->
<div id="imagen-container" style="display: none; position: fixed; bottom: 100px; right: 30px; z-index: 101; background: transparent;">
    <img id="imagen-mascota" class="d-block w-1" src="<?= Yii::getAlias('@web')?>/img/ATH/ATH_MIS.png" style="width: 500px; height: auto;">
    <!-- BOTON SIGUIENTE -->
    <button id="boton-siguiente" class="btn btn-secondary">Siguiente</button>
</div>

<!-- JS MANEJAR MASCOTA -->
<script>
document.getElementById('boton-toggle').addEventListener('click', function(event) {
    event.preventDefault();
    
    var boton = this;
    var imagenContainer = document.getElementById('imagen-container');
    
    if (imagenContainer.style.display === 'none') {
        imagenContainer.style.display = 'block';
        boton.innerHTML = 'X';
    } else {
        imagenContainer.style.display = 'none';
        boton.innerHTML = '?';
    }
});

// Array de imágenes
var imagenes = [
    "<?= Yii::getAlias('@web')?>/img/ATH/ATH_MIS.png",
    
    "<?= Yii::getAlias('@web')?>/img/ANA_MISIONES_3.png"
];
var indiceImagenActual = 0;

// Función para cambiar la imagen
function cambiarImagen() {
    indiceImagenActual = (indiceImagenActual + 1) % imagenes.length;
    document.getElementById('imagen-mascota').src = imagenes[indiceImagenActual];
}

// Evento para el botón Siguiente
document.getElementById('boton-siguiente').addEventListener('click', cambiarImagen);
</script>









    
    
    
    
    
</div>

views/misiones/mostrar.php
<style>
    
.mision-container {
    background-color: transparent;
    color: #aad399;
    border: 1px solid #aad399;
    box-shadow: 0 0 20px #aad399;
    padding: 10px 20px;
    font-size: 16px;
    font-weight: bold;
    border-radius: 15px;
    word-wrap: break-word;
    margin-bottom: 20px;
    
    transition: transform 0.5s ease, box-shadow 0.5s ease;
}

.mision-title {
    color: #f5df61;
    font-size: 24px;
}

.mision-actions a {
    color: #f5df61;
    text-decoration: none;
    margin-right: 10px;
}

@keyframes pulsate {
    0% { box-shadow: 0 0 5px #30cfd0; }
    50% { box-shadow: 0 0 20px #30cfd0; }
    100% { box-shadow: 0 0 5px #30cfd0; }
}
    
.mision-container:hover {
    animation: pulsate 2s infinite;
}
</style>


<?php
use yii\widgets\ListView;
use yii\data\ArrayDataProvider;

//suponiendo que $misionesNivel1 es un array de objetos de misiones
$dataProvider = new ArrayDataProvider([
    'allModels' => $misionesNivel1,
    'pagination' => [
        'pageSize' => 10, //cantidad de misiones por página
    ],
]);

echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => function ($model, $key, $index, $widget) {
        //como se muestra cada mision
        $content = "<div class=\"mision-container\">";
        $content .= "<p class=\"mision-title\"> " . $model->nom_mis . "</p>";
        $content .= "<p>Dificultad: " . $model->dificultad . "</p>";
        $content .= "<p>Informe: " . $model->informe . "</p>";
        $content .= "<p>Pago: " . $model->pago . "</p>"; 
        
        //botón de actualizar
        $updateUrl = Yii::$app->urlManager->createUrl(['misiones/update', 'nom_mis' => $model->nom_mis]);
        $content .= '<a href="' . $updateUrl . '" class="btn btn-success" style="background: transparent; border: none; padding: 0;">
                <img src="' . Yii::getAlias('@web') . '/img/ICONS/update.png" alt="Actualizar" width="50px">
            </a>';


        //botón de eliminar
        $deleteUrl = Yii::$app->urlManager->createUrl(['misiones/delete', 'nom_mis' => $model->nom_mis]);
        $content .= '<a href="' . $deleteUrl . '" class="btn btn-danger" data-method="post" data-confirm="¿Estás seguro de que quieres eliminar esta misión?" style="background: transparent; border: none; padding: 0;">
                <img src="' . Yii::getAlias('@web') . '/img/ICONS/borrar.png" alt="Eliminar" width="50px">
            </a>';

        
        //botón de Completar
        $content .= "<div class=\"mision-actions\">";
        $content .= "<form action=\"" . Yii::$app->urlManager->createUrl(['misiones/completar', 'nom_mis' => $model->nom_mis]) . "\" method=\"post\">";
        $content .= "<input type=\"hidden\" name=\"" . Yii::$app->request->csrfParam . "\" value=\"" . Yii::$app->request->csrfToken . "\">";
        $content .= "<button type=\"submit\" class=\"btn btn-primary\">Completar</button>";
        $content .= "</form>";
        $content .= "</div>";
        $content .= "</div>";

        return $content;
    },
    'layout' => "{summary}\n{items}\n{pager}", 
]);

    
    
    

views/misiones/mostrar1.php
<style>
    
.mision-container {
    background-color: transparent;
    color: #aad399;
    border: 1px solid #aad399;
    box-shadow: 0 0 20px #aad399;
    padding: 10px 20px;
    font-size: 16px;
    font-weight: bold;
    border-radius: 15px;
    word-wrap: break-word;
    margin-bottom: 20px;
    
    transition: transform 0.5s ease, box-shadow 0.5s ease;
}

.mision-title {
    color: #f5df61;
    font-size: 24px;
}

.mision-actions a {
    color: #f5df61;
    text-decoration: none;
    margin-right: 10px;
}

@keyframes pulsate {
    0% { box-shadow: 0 0 5px #30cfd0; }
    50% { box-shadow: 0 0 20px #30cfd0; }
    100% { box-shadow: 0 0 5px #30cfd0; }
}
    
.mision-container:hover {
    animation: pulsate 2s infinite;
}
</style>


<?php
use yii\widgets\ListView;
use yii\data\ArrayDataProvider;

//suponiendo que $misionesNivel1 es un array de objetos de misiones
$dataProvider = new ArrayDataProvider([
    'allModels' => $misionesNivel2,
    'pagination' => [
        'pageSize' => 10, //cantidad de misiones por página
    ],
]);

echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => function ($model, $key, $index, $widget) {
        //como se muestra cada mision
        $content = "<div class=\"mision-container\">";
        $content .= "<p class=\"mision-title\"> " . $model->nom_mis . "</p>";
        $content .= "<p>Dificultad: " . $model->dificultad . "</p>";
        $content .= "<p>Informe: " . $model->informe . "</p>";
        $content .= "<p>Pago: " . $model->pago . "</p>"; 
        
        //botón de actualizar
        $updateUrl = Yii::$app->urlManager->createUrl(['misiones/update', 'nom_mis' => $model->nom_mis]);
        $content .= '<a href="' . $updateUrl . '" class="btn btn-success" style="background: transparent; border: none; padding: 0;">
                <img src="' . Yii::getAlias('@web') . '/img/ICONS/update.png" alt="Actualizar" width="50px">
            </a>';

        //botón de eliminar
        $deleteUrl = Yii::$app->urlManager->createUrl(['misiones/delete', 'nom_mis' => $model->nom_mis]);
        $content .= '<a href="' . $deleteUrl . '" class="btn btn-danger" data-method="post" data-confirm="¿Estás seguro de que quieres eliminar esta misión?" style="background: transparent; border: none; padding: 0;">
                <img src="' . Yii::getAlias('@web') . '/img/ICONS/borrar.png" alt="Eliminar" width="50px">
            </a>';

        //formulario para completar la misión
        $content .= "<div class=\"mision-actions\">";
        $content .= "<form action=\"" . Yii::$app->urlManager->createUrl(['misiones/completar', 'nom_mis' => $model->nom_mis]) . "\" method=\"post\">";
        $content .= "<input type=\"hidden\" name=\"" . Yii::$app->request->csrfParam . "\" value=\"" . Yii::$app->request->csrfToken . "\">";
        $content .= "<button type=\"submit\" class=\"btn btn-primary\">Completar</button>";
        $content .= "</form>";
        $content .= "</div>";
        $content .= "</div>";

        return $content;
    },
    'layout' => "{summary}\n{items}\n{pager}", 
]);

views/misiones/mostrar2.php
<style>
    
.mision-container {
    background-color: transparent;
    color: #aad399;
    border: 1px solid #aad399;
    box-shadow: 0 0 20px #aad399;
    padding: 10px 20px;
    font-size: 16px;
    font-weight: bold;
    border-radius: 15px;
    word-wrap: break-word;
    margin-bottom: 20px;
    
    transition: transform 0.5s ease, box-shadow 0.5s ease;
}

.mision-title {
    color: #f5df61;
    font-size: 24px;
}

.mision-actions a {
    color: #f5df61;
    text-decoration: none;
    margin-right: 10px;
}

@keyframes pulsate {
    0% { box-shadow: 0 0 5px #30cfd0; }
    50% { box-shadow: 0 0 20px #30cfd0; }
    100% { box-shadow: 0 0 5px #30cfd0; }
}
    
.mision-container:hover {
    animation: pulsate 2s infinite;
}
</style>


<?php
use yii\widgets\ListView;
use yii\data\ArrayDataProvider;

//suponiendo que $misionesNivel1 es un array de objetos de misiones
$dataProvider = new ArrayDataProvider([
    'allModels' => $misionesNivel3,
    'pagination' => [
        'pageSize' => 10, //cantidad de misiones por página
    ],
]);

echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => function ($model, $key, $index, $widget) {
        //cómo se muestra cada misión
        $content = "<div class=\"mision-container\">";
        $content .= "<p class=\"mision-title\">" . $model->nom_mis . "</p>";
        $content .= "<p>Dificultad: " . $model->dificultad . "</p>";
        $content .= "<p>Informe: " . $model->informe . "</p>";
        $content .= "<p>Pago: " . $model->pago . "</p>"; 
        
        //botón de actualizar
        $updateUrl = Yii::$app->urlManager->createUrl(['misiones/update', 'nom_mis' => $model->nom_mis]);
        $content .= '<a href="' . $updateUrl . '" class="btn btn-success" style="background: transparent; border: none; padding: 0;">
                <img src="' . Yii::getAlias('@web') . '/img/ICONS/update.png" alt="Actualizar" width="50px">
            </a>';

        //botón de eliminar
        $deleteUrl = Yii::$app->urlManager->createUrl(['misiones/delete', 'nom_mis' => $model->nom_mis]);
        $content .= '<a href="' . $deleteUrl . '" class="btn btn-danger" data-method="post" data-confirm="¿Estás seguro de que quieres eliminar esta misión?" style="background: transparent; border: none; padding: 0;">
                <img src="' . Yii::getAlias('@web') . '/img/ICONS/borrar.png" alt="Eliminar" width="50px">
            </a>';

        //bormulario para completar la misión
        $content .= "<div class=\"mision-actions\">";
        $content .= "<form action=\"" . Yii::$app->urlManager->createUrl(['misiones/completar', 'nom_mis' => $model->nom_mis]) . "\" method=\"post\">";
        $content .= "<input type=\"hidden\" name=\"" . Yii::$app->request->csrfParam . "\" value=\"" . Yii::$app->request->csrfToken . "\">";
        $content .= "<button type=\"submit\" class=\"btn btn-primary\">Completar</button>";
        $content .= "</form>";
        $content .= "</div>";
        $content .= "</div>";

        return $content;
    },
    'layout' => "{summary}\n{items}\n{pager}", 
]);